<?php
/*
 * @version		1.0.7
 * @package		Joomla
 * @subpackage	Loginza
 * @copyright	Copyright (C) 2010 Piskunov Anton. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * @url 		www.a-piskunov.ru
 *
 * Component Loginza is free software. This version may have been modified pursuant to the
 * GNU General Public License, and as distributed it includes or is derivative
 * of works licensed under the GNU General Public License or other free or open
 * source software licenses. See COPYRIGHT.php for copyright notices and
 * details.
 */

defined('_JEXEC') or die( 'Restricted access' );

jimport( 'joomla.application.component.controller' );
jimport( 'joomla.application.application' );
jimport( 'joomla.user.helper' );
jimport( 'joomla.user.user' );

class LoginzaController extends JController{

	function request($token){

		$fp = fsockopen ("www.loginza.ru", 80, $errno, $errstr, 30);
		if (!$fp) {
			echo "$errstr ($errno)<br>\n";
		} else {
			$params = &JComponentHelper::getParams('com_loginza');
			$secret = $params->get("secretkey");
			$widget = $params->get("widgetid");
			$sieg = md5($token.$secret);


			fputs ($fp, "POST /api/authinfo?token=".$token."&id=".$widget."&sig=".$sieg." HTTP/1.0\r\nHost: $_SERVER[HTTP_HOST]\r\n\r\n");

				$i = 0;
				while (!feof($fp)) {
					$answer[$i] = fgets ($fp,1024);
					$i++;
				}

					$json = json_decode($answer[14], true);

			fclose ($fp);
		}
		return $json;
	}

	function generatePasswd($json){
		$params = &JComponentHelper::getParams('com_loginza');
		$secret = $params->get("secretkey");
		$passwd = $json['identity'].$secret;
		return $passwd;
	}

	function getNameProvider($json){
				//Google
				if(preg_match("/https:\/\/www.google.com\/accounts/i", $json['provider'])){$nameProvider = "google";}
				//Yandex.ru
				if($json['provider'] == 'http://openid.yandex.ru/server/'){$nameProvider = "yandex";}
				//Mail.ru
				if($json['provider'] == 'http://mail.ru/'){$nameProvider = "mailru";}
				//VKontakte
				if($json['provider'] == 'http://vkontakte.ru/'){$nameProvider = "vkontakte";}
				//Facebook
				if($json['provider'] == 'http://www.facebook.com/'){$nameProvider = "facebook";}
				//Twitter.ru
				if($json['provider'] == 'http://twitter.com/'){$nameProvider = "twitter";}
				//Loginza
				if($json['provider'] == 'https://loginza.ru/server/'){$nameProvider = "loginza";}
				//MyOpenId
				if($json['provider'] == 'http://www.myopenid.com/server'){$nameProvider = "myopenid";}
				//Web-money
				preg_match("/^(https:\/\/)?([^\/]+)?(wmkeeper.com)/", $json['identity'], $matches);
				if (!empty($matches[3])) {
					$webmoneyProvider = $matches[3];
					if($webmoneyProvider == 'wmkeeper.com'){$nameProvider = "webmoney";}
				}
				//Rambler
				if($json['provider'] == 'http://id.rambler.ru/script/openid.cgi'){$nameProvider = "rambler";}
				//Flickr
				if($json['provider'] == 'https://open.login.yahooapis.com/openid/op/auth'){$nameProvider = "flickr";}

			return $nameProvider;
	}

	function getId($json){
			$nameProvider = $this->getNameProvider($json);

				//Google
				if($nameProvider == "google"){
					preg_match("/^(https:\/\/www.google.com\/accounts\/o8\/id\?id=)?([^\/]+)/", $json['identity'], $matches);
					echo $id = $matches[2];
				}
				//Yandex.ru
				if($nameProvider == "yandex"){
					preg_match("/^(http:\/\/openid.yandex.ru\/)?([^\/]+)/", $json['identity'], $matches);
					$id = $matches[2];

					if($id == 'http:'){
						preg_match("/^(http:\/\/?([^\/]+).ya.ru)/", $json['identity'], $matches);
						$id = $matches[2];
					}
				}
				//Mail.ru
				if($nameProvider == "mailru"){
					preg_match("/^(http:\/\/my.mail.ru\/mail\/)?([^\/]+)/", $json['identity'], $matches);
					$id = $matches[2];
				}
				//VKontakte
				if($nameProvider == "vkontakte"){
					preg_match("/^(http:\/\/vkontakte.ru\/)?([^\/]+)/", $json['identity'], $matches);
					$id = $matches[2];
				}
				//Facebook
				if($nameProvider == "facebook"){
					preg_match("/^(http:\/\/www.facebook.com\/profile\.php\?id=)?([^\/]+)/", $json['identity'], $matches);
					$id = mb_strtolower($matches[2]);
				}
				//Twitter.ru
				if($nameProvider == "twitter"){
					preg_match("/^(http:\/\/twitter.com\/)?([^\/]+)/", $json['identity'], $matches);
					$id = mb_strtolower($matches[2]);
				}
				//Loginza
				if($nameProvider == "loginza"){
					preg_match("/^(http:\/\/)?([^\/]+)?(\.loginza\.ru)/", $json['identity'], $matches);
					$id = mb_strtolower($matches[2]);
				}
				//MyOpenId
				if($nameProvider == "myopenid"){
					preg_match("/^(http:\/\/?([^\/]+).myopenid.com)/", $json['identity'], $matches);
					$id = $matches[2];
				}
				//Web-money
				if($nameProvider == "webmoney"){
					preg_match("/^(https:\/\/)?([^\/]+)?(.wmkeeper.com)/", $json['identity'], $matches);
					$id = $matches[2];
				}
				//Rambler
				if($nameProvider == "rambler"){
					preg_match("/^(https:\/\/id\.rambler\.ru\/users\/)?([^\/]+)/", $json['identity'], $matches);
					$id = $matches[2];
				}
				//Flickr
				if($nameProvider == "flickr"){
					preg_match("/^(https:\/\/me\.yahoo\.com\/a\/)?([^\/]+)/", $json['identity'], $matches);
					$id = $matches[2];
				}

			return $id;
	}

	function login($json){
		$passwd = $this->generatePasswd($json);
		$nameProvider = $this->getNameProvider($json);
		$id = $this->getId($json);
		$return = base64_decode(JRequest::getVar('return',''));

			global $mainframe;

			$options = array();
			$options['remember'] = JRequest::getBool('remember', false);
			$options['return'] = $return;

			$credentials = array();
			$credentials['username'] = $id.':'.$nameProvider;
			$credentials['password'] = $passwd;

			$error = $mainframe->login($credentials, $options);

			//Отправляем пользователя на ту страницу где он был
			if (!empty($return)) {
				$mainframe->redirect($return);
			}
			else {
				//$mainframe->redirect($_COOKIE['returnurl']);
				//$mainframe->redirect($_COOKIE['returnurl']);
			}

	}

	function register($json){
		$passwd = $this->generatePasswd($json);

		$nameProvider = $this->getNameProvider($json);
		$id = $this->getId($json);

		$acl =& JFactory::getACL();
		$usersParams = &JComponentHelper::getParams( 'com_users' );
		$user = JFactory::getUser(0);
		$data = array();

		$usertype = $usersParams->get( 'new_usertype' );
			if(!$usertype){
				$usertype = 'Registered';
			}


		//e-mail
		$email = $json['email'];
		jimport('joomla.mail.helper');

		if (JMailHelper::isEmailAddress($email)) {

			$db =& JFactory::getDBO();
			$query = 'SELECT *'
					. ' FROM `#__users`'
					. ' WHERE `email` = '.$db->Quote($email);
			$db->setQuery($query);
			$db->query();
			if($db->getNumRows()){
				//Replace email with a fake name to avoid joomla user conflict
				$email = uniqid().'_.'.$email;
			}
		}
			if(empty($json['email'])){
				//VKontakte
				if($json['provider'] == 'http://vkontakte.ru/'){
					$email = $id.'@vkontakte.ru';
				}
				//Twitter.ru
				if($json['provider'] == 'http://twitter.com/'){
					$email = $id.'@twitter.com';
				}
				//Yandex.ru
				if($json['provider'] == 'http://openid.yandex.ru/server/'){
					$email = $id.'@yandex.ru';
				}
				//Mail.ru
				if($json['provider'] == 'http://mail.ru/'){
					$email = $id.'@mail.ru';
				}
				//MyOpenId
				if($json['provider'] == 'http://www.myopenid.com/server'){
					$email = $id.'@myopenid.com';
				}
				//Web-money
					preg_match("/^(https:\/\/)?([^\/]+)?(wmkeeper.com)/", $json['identity'], $matches);
					$webmoneyProvider = $matches[3];

					if($webmoneyProvider == 'wmkeeper.com'){
						$email = $id.'@webmoney.com';
					}
				//Rambler
				if($json['provider'] == 'http://id.rambler.ru/script/openid.cgi'){
					$email = $id.'@rambler.ru';
				}
			}

			//name
		$name = $json['name']['full_name'];
			if($name == null){
				$name = $json['name']['first_name'].' '.$json['name']['last_name'];
			}

			//name2
			if($name == null or $name == ' '){
				$name = $id;
			}

		$data['name'] = $name;
		$data['username'] = $id.':'.$nameProvider;
		$data['email'] = $email;
		$data['gid'] = $acl->get_group_id( '', $usertype, 'ARO' );
		$data['password'] = $passwd;
		$data['password2'] = $passwd;
		$data['sendEmail'] = 1;

		$useractivation = $usersParams->get( 'useractivation' );
			if ($useractivation == 1){
				$data['block'] = 1;
				$data['activation'] =JUtility::getHash( JUserHelper::genRandomPassword());
			}	else	{
				$data['block'] = 0;
			}

			if(!$user->bind($data)){
				JError::raiseWarning('', JText::_( $user->getError()));
				return false;
			}

			if(!$user->save()){
				JError::raiseWarning('', JText::_( $user->getError()));
				return false;
			}
	}

	function auth($json){
		$nameProvider = $this->getNameProvider($json);
		$id = $this->getId($json);

		if(isset($json['error_type']) && $json['error_type'] != null){
			global $mainframe;
			$mainframe->redirect('index.php');
		}	else	{
			$db =& JFactory::getDBO();
			$query = 'SELECT *'
					. ' FROM `#__users`'
					. ' WHERE `username` = \''.$id.':'.$nameProvider.'\'';
			$db->setQuery($query);
			$db->query();
			if($db->getNumRows()){
				//Авторизуемся
					$this->login($json);
			}	else	{
				//Регистрируемся
					$this->register($json);
					$this->login($json);
			}
		}
	}
}
?>
